/*******************************************************************************
Copyright 2016 Microchip Technology Inc. (www.microchip.com)

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

To request to license the code under the MLA license (www.microchip.com/mla_license), 
please contact mla_licensing@microchip.com
*******************************************************************************/

#ifndef APP_DEVICE_CDC_BASIC_H
#define APP_DEVICE_CDC_BASIC_H

#include <stdbool.h>
#include <stddef.h>

#include "usb_device_cdc.h"

/*********************************************************************
* Function: void APP_DeviceCDCBasicDemoInitialize(void);
*
* Overview: Initializes the demo code
*
* PreCondition: None
*
* Input: None
*
* Output: None
*
********************************************************************/
void APP_DeviceCDCBasicDemoInitialize(void);

/*********************************************************************
* Function: void APP_DeviceCDCBasicDemoTasks(void);
*
* Overview: Keeps the demo running.
*
* PreCondition: The demo should have been initialized and started via
*   the APP_DeviceCDCBasicDemoInitialize() and APP_DeviceCDCBasicDemoStart() demos
*   respectively.
*
* Input: None
*
* Output: None
*
********************************************************************/
void APP_DeviceCDCBasicDemoTasks(void);

/* ------------------------------------------------------
 * CWトレーナー関連の定義・変数
 ------------------------------------------------------ */

#define keyIn     RB5
#define sp_LAT    LATBbits.LATB7
#define tone_ON() TRISBbits.TRISB7=0
#define toneOFF() TRISBbits.TRISB7=1
#define MonCnt     20

//uint16_t keyTimer = 0;    // Keying継続時間
uint16_t MK_time  = 0;    // Mark継続時間
uint16_t SP_time  = 0;    // Space継続時間
//uint8_t  keyClean = 1;    // クリーンkey信号
uint8_t  numMark  = 1;    // Markの番号
bool     cgToMark = 0;    // 「押した」フラグ
bool     cgToSpace = 0;   // 「離した」フラグ
bool     gapDetected = 0; // Gapの検出フラグ
bool     onGoing = 0;     // 継続中フラグ
bool     modeDsp = 1;     // 表示モード

/* ------------------------------------------------------
 * UserCW_Init();
 * CWトレーナー関連の初期化
 ------------------------------------------------------ */
void UserCW_Init(void);

/* ------------------------------------------------------
 * UserCW_Tasks();
 * CWトレーナー関連の本体
 ------------------------------------------------------ */
void UserCW_Tasks(void);

#endif
